// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientExpandMapOverwriteZoneInformation.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `polygon`
#include "geometry_msgs/msg/detail/point32__functions.h"

bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__init(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(msg);
    return false;
  }
  // type
  // polygon
  if (!geometry_msgs__msg__Point32__Sequence__init(&msg->polygon, 0)) {
    bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * msg)
{
  if (!msg) {
    return;
  }
  // id
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // type
  // polygon
  geometry_msgs__msg__Point32__Sequence__fini(&msg->polygon);
}

bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__are_equal(const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * lhs, const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // polygon
  if (!geometry_msgs__msg__Point32__Sequence__are_equal(
      &(lhs->polygon), &(rhs->polygon)))
  {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__copy(
  const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * input,
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // type
  output->type = input->type;
  // polygon
  if (!geometry_msgs__msg__Point32__Sequence__copy(
      &(input->polygon), &(output->polygon)))
  {
    return false;
  }
  return true;
}

bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation *
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * msg = (bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation));
  bool success = bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__destroy(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__init(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__fini(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence *
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * array = (bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__destroy(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__are_equal(const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * lhs, const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence__copy(
  const bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * input,
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation * data =
      (bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
