// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientExpandMapVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'zones'
#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__struct.hpp"
// Member 'prior_map_poses'
#include "geometry_msgs/msg/detail/pose_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapVisualization __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapVisualization __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientExpandMapVisualization_
{
  using Type = ClientExpandMapVisualization_<ContainerAllocator>;

  explicit ClientExpandMapVisualization_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    prior_map_poses(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
    }
  }

  explicit ClientExpandMapVisualization_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    prior_map_poses(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _visualization_id_type =
    uint64_t;
  _visualization_id_type visualization_id;
  using _zones_type =
    std::vector<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>>;
  _zones_type zones;
  using _prior_map_poses_type =
    geometry_msgs::msg::PoseArray_<ContainerAllocator>;
  _prior_map_poses_type prior_map_poses;
  using _prior_map_pose_types_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _prior_map_pose_types_type prior_map_pose_types;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__visualization_id(
    const uint64_t & _arg)
  {
    this->visualization_id = _arg;
    return *this;
  }
  Type & set__zones(
    const std::vector<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>> & _arg)
  {
    this->zones = _arg;
    return *this;
  }
  Type & set__prior_map_poses(
    const geometry_msgs::msg::PoseArray_<ContainerAllocator> & _arg)
  {
    this->prior_map_poses = _arg;
    return *this;
  }
  Type & set__prior_map_pose_types(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->prior_map_pose_types = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapVisualization_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientExpandMapVisualization_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->visualization_id != other.visualization_id) {
      return false;
    }
    if (this->zones != other.zones) {
      return false;
    }
    if (this->prior_map_poses != other.prior_map_poses) {
      return false;
    }
    if (this->prior_map_pose_types != other.prior_map_pose_types) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientExpandMapVisualization_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientExpandMapVisualization_

// alias to use template instance with default allocator
using ClientExpandMapVisualization =
  bosch_locator_bridge::msg::ClientExpandMapVisualization_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_HPP_
