// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:msg/ClientExpandMapVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/msg/detail/client_expand_map_visualization__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'zones'
#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__traits.hpp"
// Member 'prior_map_poses'
#include "geometry_msgs/msg/detail/pose_array__traits.hpp"

namespace bosch_locator_bridge
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClientExpandMapVisualization & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: visualization_id
  {
    out << "visualization_id: ";
    rosidl_generator_traits::value_to_yaml(msg.visualization_id, out);
    out << ", ";
  }

  // member: zones
  {
    if (msg.zones.size() == 0) {
      out << "zones: []";
    } else {
      out << "zones: [";
      size_t pending_items = msg.zones.size();
      for (auto item : msg.zones) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: prior_map_poses
  {
    out << "prior_map_poses: ";
    to_flow_style_yaml(msg.prior_map_poses, out);
    out << ", ";
  }

  // member: prior_map_pose_types
  {
    if (msg.prior_map_pose_types.size() == 0) {
      out << "prior_map_pose_types: []";
    } else {
      out << "prior_map_pose_types: [";
      size_t pending_items = msg.prior_map_pose_types.size();
      for (auto item : msg.prior_map_pose_types) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClientExpandMapVisualization & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: visualization_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "visualization_id: ";
    rosidl_generator_traits::value_to_yaml(msg.visualization_id, out);
    out << "\n";
  }

  // member: zones
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.zones.size() == 0) {
      out << "zones: []\n";
    } else {
      out << "zones:\n";
      for (auto item : msg.zones) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: prior_map_poses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prior_map_poses:\n";
    to_block_style_yaml(msg.prior_map_poses, out, indentation + 2);
  }

  // member: prior_map_pose_types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.prior_map_pose_types.size() == 0) {
      out << "prior_map_pose_types: []\n";
    } else {
      out << "prior_map_pose_types:\n";
      for (auto item : msg.prior_map_pose_types) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClientExpandMapVisualization & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::msg::ClientExpandMapVisualization & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::msg::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::msg::ClientExpandMapVisualization & msg)
{
  return bosch_locator_bridge::msg::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::msg::ClientExpandMapVisualization>()
{
  return "bosch_locator_bridge::msg::ClientExpandMapVisualization";
}

template<>
inline const char * name<bosch_locator_bridge::msg::ClientExpandMapVisualization>()
{
  return "bosch_locator_bridge/msg/ClientExpandMapVisualization";
}

template<>
struct has_fixed_size<bosch_locator_bridge::msg::ClientExpandMapVisualization>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<bosch_locator_bridge::msg::ClientExpandMapVisualization>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<bosch_locator_bridge::msg::ClientExpandMapVisualization>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__TRAITS_HPP_
