// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from bosch_locator_bridge:msg/ClientMapVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_H_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_STARTUP'.
/**
  * Constants
 */
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_RECORDING_STATUS_STARTUP = -2l
};

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_DELAYED'.
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_RECORDING_STATUS_DELAYED = 1l
};

/// Constant 'CLIENT_RECORDING_RECORDING_STATUS_OK'.
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_RECORDING_STATUS_OK = 2l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL'.
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL = 0l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE'.
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE = 1l
};

/// Constant 'CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE'.
enum
{
  bosch_locator_bridge__msg__ClientMapVisualization__CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE = 2l
};

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'path_types'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/ClientMapVisualization in the package bosch_locator_bridge.
/**
  * Copyright (c) 2021 - for information on the respective copyright owner
  * see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
  *
  *     http://www.apache.org/licenses/LICENSE-2.0
  *
  * Unless required by applicable law or agreed to in writing, software
  * distributed under the License is distributed on an "AS IS" BASIS,
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
 */
typedef struct bosch_locator_bridge__msg__ClientMapVisualization
{
  /// The time at which the Localization Client received the laser scan used to generate this Datagram
  builtin_interfaces__msg__Time timestamp;
  /// A unique id for matching datagrams that were emitted at the same time but by different visualization interfaces
  uint64_t visualization_id;
  /// The ClientRecordingRecordingStatus
  int32_t status;
  /// Distance traversed by the sensor since the last successful loop closure
  double distance_to_last_lc;
  /// The relative delay within the system when processing laser scans.
  /// 0: no delay; 1.0 : delay causes loop closures to be omitted when building the temporary map
  double delay;
  /// Currently unused
  double progress;
  /// Please note that pose, scan, and path_poses is published directly via the standard message types (custom nested messages would hinder using ros tools, such as rviz)
  ///  Array of order state_1, state_2, using the ClientRecordingPathTypeEnum
  rosidl_runtime_c__int32__Sequence path_types;
} bosch_locator_bridge__msg__ClientMapVisualization;

// Struct for a sequence of bosch_locator_bridge__msg__ClientMapVisualization.
typedef struct bosch_locator_bridge__msg__ClientMapVisualization__Sequence
{
  bosch_locator_bridge__msg__ClientMapVisualization * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} bosch_locator_bridge__msg__ClientMapVisualization__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_H_
