// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:msg/ClientGlobalAlignLandmarkObservationNotice.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/msg/detail/client_global_align_landmark_observation_notice__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace bosch_locator_bridge
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClientGlobalAlignLandmarkObservationNotice & msg,
  std::ostream & out)
{
  out << "{";
  // member: pose_index
  {
    out << "pose_index: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_index, out);
    out << ", ";
  }

  // member: landmark_index
  {
    out << "landmark_index: ";
    rosidl_generator_traits::value_to_yaml(msg.landmark_index, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClientGlobalAlignLandmarkObservationNotice & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_index: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_index, out);
    out << "\n";
  }

  // member: landmark_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "landmark_index: ";
    rosidl_generator_traits::value_to_yaml(msg.landmark_index, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClientGlobalAlignLandmarkObservationNotice & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::msg::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice & msg)
{
  return bosch_locator_bridge::msg::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice>()
{
  return "bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice";
}

template<>
inline const char * name<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice>()
{
  return "bosch_locator_bridge/msg/ClientGlobalAlignLandmarkObservationNotice";
}

template<>
struct has_fixed_size<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<bosch_locator_bridge::msg::ClientGlobalAlignLandmarkObservationNotice>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_GLOBAL_ALIGN_LANDMARK_OBSERVATION_NOTICE__TRAITS_HPP_
