// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:srv/ServerMapList.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__SERVER_MAP_LIST__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__SERVER_MAP_LIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/srv/detail/server_map_list__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace bosch_locator_bridge
{

namespace srv
{

inline void to_flow_style_yaml(
  const ServerMapList_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ServerMapList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ServerMapList_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::srv::ServerMapList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::srv::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::srv::ServerMapList_Request & msg)
{
  return bosch_locator_bridge::srv::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::srv::ServerMapList_Request>()
{
  return "bosch_locator_bridge::srv::ServerMapList_Request";
}

template<>
inline const char * name<bosch_locator_bridge::srv::ServerMapList_Request>()
{
  return "bosch_locator_bridge/srv/ServerMapList_Request";
}

template<>
struct has_fixed_size<bosch_locator_bridge::srv::ServerMapList_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<bosch_locator_bridge::srv::ServerMapList_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<bosch_locator_bridge::srv::ServerMapList_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace bosch_locator_bridge
{

namespace srv
{

inline void to_flow_style_yaml(
  const ServerMapList_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: names
  {
    if (msg.names.size() == 0) {
      out << "names: []";
    } else {
      out << "names: [";
      size_t pending_items = msg.names.size();
      for (auto item : msg.names) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ServerMapList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.names.size() == 0) {
      out << "names: []\n";
    } else {
      out << "names:\n";
      for (auto item : msg.names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ServerMapList_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::srv::ServerMapList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::srv::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::srv::ServerMapList_Response & msg)
{
  return bosch_locator_bridge::srv::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::srv::ServerMapList_Response>()
{
  return "bosch_locator_bridge::srv::ServerMapList_Response";
}

template<>
inline const char * name<bosch_locator_bridge::srv::ServerMapList_Response>()
{
  return "bosch_locator_bridge/srv/ServerMapList_Response";
}

template<>
struct has_fixed_size<bosch_locator_bridge::srv::ServerMapList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<bosch_locator_bridge::srv::ServerMapList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<bosch_locator_bridge::srv::ServerMapList_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<bosch_locator_bridge::srv::ServerMapList>()
{
  return "bosch_locator_bridge::srv::ServerMapList";
}

template<>
inline const char * name<bosch_locator_bridge::srv::ServerMapList>()
{
  return "bosch_locator_bridge/srv/ServerMapList";
}

template<>
struct has_fixed_size<bosch_locator_bridge::srv::ServerMapList>
  : std::integral_constant<
    bool,
    has_fixed_size<bosch_locator_bridge::srv::ServerMapList_Request>::value &&
    has_fixed_size<bosch_locator_bridge::srv::ServerMapList_Response>::value
  >
{
};

template<>
struct has_bounded_size<bosch_locator_bridge::srv::ServerMapList>
  : std::integral_constant<
    bool,
    has_bounded_size<bosch_locator_bridge::srv::ServerMapList_Request>::value &&
    has_bounded_size<bosch_locator_bridge::srv::ServerMapList_Response>::value
  >
{
};

template<>
struct is_service<bosch_locator_bridge::srv::ServerMapList>
  : std::true_type
{
};

template<>
struct is_service_request<bosch_locator_bridge::srv::ServerMapList_Request>
  : std::true_type
{
};

template<>
struct is_service_response<bosch_locator_bridge::srv::ServerMapList_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__SERVER_MAP_LIST__TRAITS_HPP_
